import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;

public class CD_DA extends JFrame{

  Status state;
  final String akt="CD_DA";

  Container c;
  JButton enc,dec;
  JMenuBar menuBar;
  JMenu m1, m2,m3,m4,m5;
  JMenuItem m11,m12,m21,m22,m31,m41,m51,m52;

  /*Overview for encoding and decoding*/

  public CD_DA(Status st){
    super("CIRC");

    state=st;

    c=getContentPane();
    c.setLayout(null);

    setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

    //Menu Bar
    menuBar=new JMenuBar();
    m1=new JMenu("File");
    m2=new JMenu("View");
    m3=new JMenu("Menu");
    m4=new JMenu("Circ-Overview");
    m5=new JMenu("?");

    m11=new JMenuItem("New");
    m11.setEnabled(false);
    m1.add(m11);
    m1.addSeparator();

    m12=new JMenuItem("Quit");
    m12.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){

      }
    });
    m1.add(m12);

    menuBar.add(m1);

    m21=new JMenuItem("Back");
    m21.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }
    });
    m2.add(m21);
    m2.addSeparator();

    m22=new JMenuItem("Next");
    m22.setEnabled(false);
    m2.add(m22);

    menuBar.add(m2);

    m31=new JMenuItem("Menu");
    m31.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }
    });
    m3.add(m31);

    menuBar.add(m3);

    m41=new JMenuItem("Circ-Overview");
    m41.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showRS(akt);
      }
    });
    m4.add(m41);

    menuBar.add(m4);

    m51=new JMenuItem("Help");
    m51.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showHelp(akt);
      }
    });
    m5.add(m51);
    m5.addSeparator();

    m52=new JMenuItem("<html>GF(2<SUP>4</SUP>)</html>");
    m52.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showGF();
      }
    });
    m5.add(m52);

    menuBar.add(m5);

    setJMenuBar(menuBar);
    /* Button for the Encoding */
    enc=new JButton("CIRC-Encoding");
    enc.setBounds(40,40,200,50);
    enc.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.nextState(akt,"Circ1");
      }
    });

    c.add(enc);
    /* Button for the Decoding */
    dec=new JButton("CIRC-Decoding");
    dec.setBounds(40,160,200,50);
    dec.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.nextState(akt,"CircDec");
      }
    });
    c.add(dec);

    setSize(300,300);
    setVisible(true);
  }
}

