import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.*;


public class OverviewCIRC extends JFrame{

  int x=0;
  int y=0;
  int w=0;
  int h=0;

  Image image;
  public OverviewCIRC(Image image){
    super("CIRC-Overview");
    Container c=getContentPane();
    this.image=image;
    setSize(this.image.getWidth(this)+40,this.image.getHeight(this)+40 );
    repaint();
  }

  public void setRec(int a,int b,int c,int d){
    x=a;
    y=b;
    w=c;
    h=d;
    repaint();
  }

  public void back(){
    x=0;
    y=0;
    w=0;
    h=0;
    repaint();
  }

  /*build a rect */
  public void paint(Graphics g){
    super.paint(g);
    g.drawImage( image, 20, 30, this );

    g.setColor(Color.red);
    Graphics2D g2=(Graphics2D)g;
    Stroke stroke = new BasicStroke( 3 );
    g2.setStroke( stroke );
    if(!(x==0&&y==0&&w==0&&h==0))
      g2.drawRect(x,y,w,h);
  }
}