import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import java.applet.*;
import javax.swing.border.*;


//Overview GUI for the cdrom error correction;
public class OverviewcdromMode2Form1 extends JFrame{

  Status state;
  final String akt="OverviewcdromMode2Form1";

  Container c;

  JMenuBar menuBar;
  JMenu m1, m2,m3,m4,m5;
  JMenuItem m11,m12,m21,m22,m31,m41,m51,m52;

  public OverviewcdromMode2Form1(Status st){
    super("CD-ROM / XA Mode 2 Form 1 - Overview");

    state=st;

    //MenuBar
    menuBar=new JMenuBar();
    m1=new JMenu("File");
    m2=new JMenu("View");
    m3=new JMenu("Menu");
    m4=new JMenu("Circ-Overview");
    m5=new JMenu("?");

    m11=new JMenuItem("New");
    m11.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){

      }
    });
    m11.setEnabled(false);
    m1.add(m11);
    m1.addSeparator();

    m12=new JMenuItem("Quit");
    m12.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.close(akt);
      }
    });
    m1.add(m12);

    menuBar.add(m1);

    m21=new JMenuItem("Back");
    m21.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }
    });
    m2.add(m21);
    m2.addSeparator();

    m22=new JMenuItem("Next");
    m22.setEnabled(false);
    m2.add(m22);

    menuBar.add(m2);

    m31=new JMenuItem("Menu");
    m31.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }
    });
    m3.add(m31);

    menuBar.add(m3);

    m41=new JMenuItem("Circ-Overview");
    m41.setEnabled(false);
    m4.add(m41);

    menuBar.add(m4);

    m51=new JMenuItem("Help");
    m51.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showHelp(akt);
      }
    });
    m5.add(m51);
    m5.addSeparator();

    m52=new JMenuItem("<html>GF(2<SUP>4</SUP>)</html>");
    m52.setEnabled(false);
    m5.add(m52);

    menuBar.add(m5);

    setJMenuBar(menuBar);

    JButton edc = new JButton(" CRC ");
    JButton ecc = new JButton(" RSPC ");
    JButton circ = new JButton(" CIRC ");
    JLabel l1 = new JLabel("1. Error Correction Layer: ");
    JLabel l2 = new JLabel("2. Error Correction Layer: ");
    JLabel l3 = new JLabel("a) Error Detection Code: ");
    JLabel l4 = new JLabel("b) Error Correction Code: ");
    JPanel mitte= new JPanel();

    c=getContentPane();
    c.add(mitte);

    setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

    Border border1=BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    mitte.setBorder(new TitledBorder(border1,"CD-ROM/ XA Mode 2 Form 1"));


    mitte.setLayout(null);
    mitte.add(l1);
    mitte.add(l2);
    mitte.add(l3);
    mitte.add(l4);
    mitte.add(edc);
    mitte.add(ecc);
    mitte.add(circ);

    l1.setBounds(30,60,200,25);
    l2.setBounds(30,130,200,25);
    l3.setBounds(200,130,200,25);
    l4.setBounds(200,180,200,25);
    edc.setBounds(370,130,80,25);
    ecc.setBounds(370,180,80,25);
    circ.setBounds(200,60,80,25);

    circ.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.nextState(akt,"CD_DA");
      }
    });

    edc.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.nextState(akt,"CRCGUI");
      }
    });

    ecc.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.nextState(akt,"RSPC");
      }
    });
    setSize(350,750);
    setVisible(true);
  }
}
