//zu viele 0en; heute noch bearbeiten;
import java.util.*;
import java.lang.*;

public class Qparicode {

	private long time;
  private int infoword_binaer[][]= new int[8][4];
  private int helparray[]= new int[4];
  private Random r = new Random();
  private int g,i,h,l;//variables
  int k=0; int a=0; int j=0; int w=0; int x=0; int z=0; int s=0; int t=0;int y=0;//variables
  private int divisor_binaer [][]= new int[14][4];
  private int multiply_binaer[][]= new int[7][4];
  private int divisor_betas []  = new int[14];
  private int multiply_betas[]  = new int[7];
  private int help=0;
  private String[] info_bin = new String[8];
  private String[] solu_bin1= new String[6];
  private String[] info_bin2= new String[8];
  private int[][] gaulois={{0,0,0,0},     //Gauloisfield in the binary state
                           {1,0,0,1},
                           {0,0,0,1},
                           {0,0,1,0},
                           {0,1,0,0},
                           {1,0,0,0},
                           {0,0,1,1},
                           {0,1,1,0},
                           {1,1,0,0},
                           {1,0,1,1},
                           {0,1,0,1},
                           {1,0,1,0},
                           {0,1,1,1},
                           {1,1,1,0},
                           {1,1,1,1},
                           {1,1,0,1}};
  private int [] beta1={0,14,15,1,2,3,4,5,6,7,8,9,10,11,12,13};//Exponents of the betas from the gaulois field
  private int genpol_binaer[][]= {{0,0,0,1},   //generator polynomial in the binary state;
                                 {0,1,1,1},
                                 {1,0,0,1},
                                 {0,0,1,1},
                                 {1,1,0,0},
                                 {1,0,1,0},
                                 {1,1,0,0}};
  private int genpol_betas[]={0,10,14,4,6,9,6};


  public Qparicode(int diff){
    Werte(diff);
    Infowort_binaer();

    while (y < 8) {
      Divisor_beta2();
      Compute_betas();
      if(divisor_binaer[0][0]==0 && divisor_binaer[0][1]==0 &&
          divisor_binaer[0][2]==0 && divisor_binaer[0][3]==0 && y<7){
         break;
       }
      Change_betas();
      Add();
      Solution();
      y++;
   }
   Solu_for_app();


  }

  //Get the informationwords to compute the parity
  private String[] Werte(int diff){
    int anz=0;
    if(diff==0)
      anz=4;
    else if(diff==1)
      anz=2;
    else anz=0;
    for ( i = 0; i < anz; i++) {
      info_bin[i]="0000";
      for ( g = 0; g < 4; g++) {
        infoword_binaer[i][g] = 0;
      }
    }
    for(int i=anz;i<8;i++){
      info_bin[i]="";
      for ( g = 0; g < 4; g++) {
        infoword_binaer[i][g] = r.nextInt(2);
        info_bin[i]=info_bin[i]+infoword_binaer[i][g];
      }
      if(i==7 && info_bin[i]=="0000")
        i--;
    }
    return info_bin;
  }

  /* Infowort_binaer() returns the informationword in the Bitstring and puts the 0`s
     in dependency of the highest exponent of the generator polynomial*/

  private int [][] Infowort_binaer(){
  	time=System.currentTimeMillis();
    for (h = 0; h < 14; h++) {
      for (g = 0; g < 4; g++) {
        if(h<8){
          divisor_binaer[h][g] = infoword_binaer[h][g];
        }else divisor_binaer[h][g]=0;
      }
    }
    return divisor_binaer;
  }


  /* Changes the bitstring into the Exponents of the betas;
     they are needed for the Modulo-Division*/
  private int[] Divisor_beta2(){
    int v = 0;
    int b = 0;
    int k = 0;
    while (k < 14) {
      for (v = 0; v < 16; v++){
        for (i = 0; i < 4; i++){
          if (divisor_binaer[k][i] != gaulois[v][i]) {
            b = 0;
            break;
          }
          else{
            b++;
            if(b == 4){
              divisor_betas[k]=beta1[v];
            }
          }
        }
      }
      k++;
    }
    return divisor_betas;
  }

  /* Compute the betas of the first step*/
  private int[] Compute_betas(){
    while(divisor_binaer[0][0]==0 && divisor_binaer[0][1]==0 &&
          divisor_binaer[0][2]==0 && divisor_binaer[0][3]==0 && y<7){

      Solution();
      y++;
    }

    help=divisor_betas[0]+genpol_betas[0];
    for(j=0;j<7;j++){
      multiply_betas[j]=genpol_betas[j] + help;
	}
    return multiply_betas;
  }

  /* The Betas of the first step of the computation have to changed in binary words */
  private int[][] Change_betas(){
    w=0;
    while(w<7){
      for (h = 0; h < 16; h++) {
        if (multiply_betas[w] == beta1[h]) {
          for (l = 0; l < 4; l++) {
            multiply_binaer[w][l] = gaulois[h][l];
          }
        }else{
          while (multiply_betas[w] > 15) {
            multiply_betas[w] = multiply_betas[w] - 15;
          }if(multiply_betas[w] == beta1[h]){
            for (l = 0; l < 4; l++){
              multiply_binaer[w][l] = gaulois[h][l];
            }
          }
        }
      }
      w++;
    }
    return multiply_binaer;
  }
//the words are added, that you can go to the next step;
  private int [][] Add(){
    j=0;
    i=0;
    for (j = 0; j < 7; j++) {
      for (i = 0; i < 4; i++) {
        divisor_binaer[j][i]=(multiply_binaer[j][i]+divisor_binaer[j][i])%2;
      }
    }
    return divisor_binaer;
  }
//builds the arry for the parity bits;
  private int [][] Solution(){
    w=0;
    x=0;
    for (int w = 0; w < 12; w++) {
      divisor_betas[w]=divisor_betas[w+1];
      for (int x = 0; x < 4; x++) {
        divisor_binaer[w][x] = divisor_binaer[w + 1][x];
      }
    }
    return divisor_binaer;
  }
//changes the array, where the parity bits are, in a String array;
  private String[] Solu_for_app(){
    x=0;
    for (s= 0; s < 6; s++) {
      solu_bin1[s]="";
      for(int x = 0; x < 4; x++){
        solu_bin1[s]=solu_bin1[s]+divisor_binaer[s][x];
      }
    }

    return solu_bin1;
  }
  public String[] get_Werte(){
    return info_bin;
  }

  public String[] get_Solu_for_app(){
    return solu_bin1;
  }

public int[][] get_Infowort_binaer(){
    return infoword_binaer;
  }

    public String getTime(){
		return Long.toString((System.currentTimeMillis()-time)/1000);
	}

}