import java.awt.Image;
import java.lang.*;
import javax.swing.*;
import javax.swing.*;
import java.util.*;

public class Status{

  private Image circ;
  private Image right,wrong;

  //frame-classes
  private AppletOverview applet;
  private Overview t;
  private CD_DA cd;
  private Overviewcdrom cdrom;
  private OverviewForm2 form;
  private Circ1 c1;
  private CIRC2 c2;
  private CIRC3 c3;
  private CIRC4 c4;
  private CircDec dec;
  private CRCGUI crc;
  private RSPC rspc;
  private OverviewcdromMode2Form1 ocmf;

  private Parity p;
  private OverviewCIRC u;
  private GF gf;

  private String state[],user,passwd;
  private int[] difficulty;
  private int[] valuation;
  private String[] time;
  private int[] z_diff;

  private int state_zaehler;
  private int[][] index=new int[][]{
  	//window-size of all frames
      {500,700},{300,350},{500,350},{500,750},
      {500,745},{500,670},{500,745},{500,650},
      {500,720},{500,765},{400,300},{500,350}
  };

  private final String id[]={
  	//id of all frames
      "Overview","CD_DA","Overviewcdrom","Circ1",
      "CIRC2","CIRC3","CIRC4","CircDec",
      "CRCGUI","RSPC","OverviewForm2","OverviewcdromMode2Form1"
  };

  public Status(String user,String passwd,Image c,Image r,Image w,AppletOverview applet){
    this.user=user;
    this.passwd=passwd;
    valuation=new int[3];
    difficulty=new int[3];
    for(int i=0;i<3;i++){
      difficulty[i]=1;
    }
    time=new String[3];
    z_diff=new int[9];
    circ=c;
    right=r;
    wrong=w;
    this.applet=applet;

    //save the way, which the user "goes" through the applet
    state=new String[10];
    state[0]="Overview";
    state_zaehler=0;

            //show the first frame "Overview"
    t=new Overview(this);
    visible(t);
  }

  public String send(String akt){
    	//sends applet values from the user to server and returns the feedback
    results k1 = new results();
    //k1.serverip=;
    //k1.serverport=;
    //k1.sourceip=;
    //k1.sourceport=;

    k1.command ="ergeing";
    k1.destip ="192.168.17.50";
    k1.destport = 3200;

    k1.id ="cdcorr"+getIDGroup(akt);
    k1.password=passwd;

    k1.appletid="1";
    k1.difficulty=""+difficulty[getIDGroup(akt)];
    k1.valuation=""+valuation[getIDGroup(akt)];
    k1.time =""+time[getIDGroup(akt)];

    k1.status();
    k1.send();
    k1.status();
    return k1.feedback;
  }


  private JFrame getObject(String s){
    	/*identifies the applet with an id "s" and returns the appropriate frame-object
    	  if object equals null, a new object is generated*/
    if(s.equals("Overview")){
      if(t==null)t=new Overview(this);
      return t;
    }else if(s.equals("CD_DA")){
      if(cd==null)cd=new CD_DA(this);
      return cd;
    }else if(s.equals("Overviewcdrom")){
      if(cdrom==null)cdrom=new Overviewcdrom(this);
      return cdrom;
    }else if(s.equals("Circ1")){
      if(c1==null)c1=new Circ1(this,right,wrong);
      return c1;
    }else if(s.equals("CIRC2")){
      if(c2==null)c2=new CIRC2(this,right,wrong);
      return c2;
    }else if(s.equals("CIRC3")){
      if(c3==null)c3=new CIRC3(this,right,wrong);
      return c3;
    }else if(s.equals("CIRC4")){
      if(c4==null)c4=new CIRC4(this,right,wrong);
      return c4;
    }else if(s.equals("CircDec")){
      if(dec==null)dec=new CircDec(this,right,wrong);
      return dec;
    }else if(s.equals("CRCGUI")){
      if(crc==null)crc=new CRCGUI(this,right,wrong);
      return crc;
    }else if(s.equals("RSPC")){
      if(rspc==null)rspc=new RSPC(this,right,wrong);
      return rspc;
    }else if(s.equals("OverviewForm2")){
      if(form==null)form=new OverviewForm2(this);
      return form;
     }else if(s.equals("OverviewcdromMode2Form1")){
       if (ocmf == null)
         ocmf = new OverviewcdromMode2Form1(this);
       return ocmf;
     }

    return new JFrame();
  }

  private int getIndex(String s){
    	//this method returns the index of String "s" in array id
    for(int i=0;i<id.length;i++){
      if(id[i].equals(s))
        return i;
    }
    return -1;
  }

  public void nextState(String akt,String next){
    	/*this method is responsable, if user pressed next-button, that the
    	actuall frame, with id "akt",and all "help-frames" GF,Uebersicht,...
    	will invisble, the frame, with id "next", and all "help-frames" of the
    	next-fram,  will visible.*/
    state_zaehler++;
    state[state_zaehler]=next;
    testUebersicht(akt);
    testGF(akt);
    invisible(getObject(akt));
    visible(getObject(next));
  }

  public void lastState(String akt){
   	/*if user pressed button "back", the frame with the id state[state_zaehler]
    	  will visible.*/
    invisible(getObject(akt));
    state_zaehler--;
    testUebersicht(akt);
    testGF(akt);
    testParity(akt);
    visible(getObject(state[state_zaehler]));
  }


  public void showMenu(String akt){
    	/*this method shows the menu and all frames, which are visible at the moment
    	  are changed to invisible.*/
    invisible(getObject(akt));
    testUebersicht(akt);
    testGF(akt);
    testParity(akt);
    state=new String[8];
    state_zaehler=0;
    state[0]="Overview";
    visible(getObject("Overview"));
  }

  public void showRS(String akt){
    	//This method shows RS-frame with the appropriate red rectangle
    if(u==null)u=new OverviewCIRC(circ);
    if(akt.equals("CD_DA")||akt.equals("CircDec"))
      u.back();
    if(akt.equals("Circ1"))
      u.setRec(30,50,80,190);
    if(akt.equals("CIRC2"))
      u.setRec(110,50,80,190);
    if(akt.equals("CIRC3"))
      u.setRec(190,50,40,190);
    if(akt.equals("CIRC4"))
      u.setRec(240,50,80,190);

    u.setSize(500,280);
    u.setVisible(true);
    if(state[state_zaehler].equals("CircDec"))
    	u.setLocation(500,420);
    else u.setLocation(500,50);
  }

  public void showGF(){
    //this method shows the GF-frame
    if(gf==null)gf=new GF();
    gf.setSize(330,380);
    gf.setVisible(true);
    if(state[state_zaehler].equals("CircDec"))
    	gf.setLocation(520,30);
    else gf.setLocation(520,340);
  }

  public void showParity(){
  	        	//this method shows the Parity-frame
    if(p==null)p=new Parity();
    p.setSize(250,225);
    p.setVisible(true);
    p.setLocation(520,50);
  }

  private void testUebersicht(String akt){
    if((akt.equals("CD_DA")||akt.equals("Circ1")||akt.equals("CIRC2")||
        akt.equals("CIRC3")||akt.equals("CIRC4")||akt.equals("CircDec"))&&u!=null){
      invisible(u);
    }
  }

  private void testGF(String akt){
    if((akt.equals("CD_DA")||akt.equals("Circ1")||akt.equals("CIRC2")||
        akt.equals("CIRC3")||akt.equals("CIRC4")||akt.equals("CircDec"))&&gf!=null){
      invisible(gf);
    }
  }

  private void testParity(String akt){
    if(akt.equals("RSPC"))
      invisible(p);
  }

  private void visible(JFrame f){
    /*this method shows frame f. If f equals Circ1/2/3/4, then show appropriate
       help-frames*/
    int i=getIndex(state[state_zaehler]);
    f.setSize(index[i][0],index[i][1]);
    f.setVisible(true);
    if((f instanceof CIRC2)||(f instanceof CIRC4)||(f instanceof CircDec))
      showGF();
    if((f instanceof Circ1)||(f instanceof CIRC2)||
       (f instanceof CIRC3)||(f instanceof CIRC4))
      showRS(state[state_zaehler]);
    if(f instanceof RSPC)
      showParity();
  }

  private void invisible(JFrame f){
    f.setVisible(false);
    f.dispose();
  }

  public void showHelp(String akt){
  	 showHelp(akt,0);
  }

  public void showHelp(String akt,int dec){
  	String s=new String();
  	if(akt.equals("Overview")){
  		s="onlinehelp.html#ovve";
  	}else if(akt.equals("CD_DA")){
  		s="onlinehelp.html#OvCIRC";
  	}else if(akt.equals("Circ1")){
  		s="onlinehelp.html#delay";
  	}else if(akt.equals("CIRC2")){
  		s="onlinehelp.html#qp";
  	}else if(akt.equals("CIRC3")){
  		s="onlinehelp.html#il";
  	}else if(akt.equals("CIRC4")){
  		s="onlinehelp.html#pp";
  	}else if(akt.equals("CircDec")){
  		s="onlinehelp.html#cidec";
  	}else if(akt.equals("Overviewcdrom")||akt.equals("OverviewForm2")){
  			s="onlinehelp.html#ovcd";
  	}else if(akt.equals("CRCGUI")){
  		if(dec==0)
  	 		s="onlinehelp.html#crcenc";
  	 	else
  	 		s="onlinehelp.html#crcdec";
  	}else if(akt.equals("RSPC")){
  		if(dec==0)
  			s="onlinehelp.html#rspcenc";
  		else
  			s="onlinehelp.html#rspcdec";
  	}
    applet.showHelp(s);
  }

  private int getIDGroup(String akt){
    /*this method return the appropriate appletid of a frame with id akt.
       appletid=0 => Circ1,CIRC2,CIRC3,CIRC4,CircDec
       appletid=1 => CRC
       appletid=2 => RSPC*/
    if(akt.equals("Circ1")||akt.equals("CIRC2")||akt.equals("CIRC3")||
       akt.equals("CIRC4")||akt.equals("CircDec")){
      return 0;
    }else if(akt.equals("CRCGUI")){
      return 1;
    }else{
      //akt.equals("RSPC");
      return 2;
    }
  }

  public void setValuation(String akt,int value){
    /*changes the value valuation of the appropriate IDGroup*/
    valuation[getIDGroup(akt)]+=value;
  }

  public void setDifficulty(String akt){
    setDifficulty(akt,0);
  }

  public void setDifficulty(String akt,int encDec){
    /*encDec=0 encoding-frame
          encDec=1 decoding-frame
          changes the difficulty of the appropriate IDGroup by a definite value */
    if(akt.equals("Circ1")&&z_diff[0]<1){
      difficulty[getIDGroup(akt)]+=1;
      z_diff[0]++;
    }else if(akt.equals("CIRC2")&&z_diff[1]<3){
      difficulty[getIDGroup(akt)]+=50;
      z_diff[1]++;
    }else if(akt.equals("CIRC3")&&z_diff[2]<1){
      difficulty[getIDGroup(akt)]+=1;
      z_diff[2]++;
    }else if(akt.equals("CIRC4")&&z_diff[3]<3){
      difficulty[getIDGroup(akt)]+=50;
      z_diff[3]++;
    }else if(akt.equals("CircDec")&&z_diff[4]<1){
      difficulty[getIDGroup(akt)]+=40;
      z_diff[4]++;
    }else if(akt.equals("CRCGUI")){
      if(encDec==0&&z_diff[5]<3){
        difficulty[getIDGroup(akt)]+=10;
        z_diff[5]++;
      }else if(encDec==1&&z_diff[6]<3){
        difficulty[getIDGroup(akt)]+=16;
        z_diff[6]++;
      }
    }else if(akt.equals("RSPC")){
      if(encDec==0&&z_diff[7]<3){
        difficulty[getIDGroup(akt)]+=10;
        z_diff[7]++;
      }else if(encDec==1&&z_diff[8]<3){
        difficulty[getIDGroup(akt)]+=16;
        z_diff[8]++;
      }
    }
  }

  public void setTime(String akt,String time){
    /*this method save time, that user needed at last and send a feedback to
       frame with id akt*/
    this.time[getIDGroup(akt)]=time;
    setSendReturn(akt);
  }

  private void setSendReturn(String akt){
    /*this method shows the 3 values difficulty,valuation and time at actuall
       visible frame*/
    JFrame f=getObject(akt);
    if(f instanceof Circ1){
      c1.sendReturn("difficulty="+difficulty[0]+"  valuation="+valuation[0]+"  time="+time[0]);
      if(c2!=null)c2.sendReturn("");
      if(c3!=null)c3.sendReturn("");
      if(c4!=null)c4.sendReturn("");
      if(dec!=null)dec.sendReturn("");
    }else if(f instanceof CIRC2){
      if(c1!=null)c1.sendReturn("");
      if(c3!=null)c3.sendReturn("");
      if(c4!=null)c4.sendReturn("");
      if(dec!=null)dec.sendReturn("");
      c2.sendReturn("difficulty="+difficulty[0]+"  valuation="+valuation[0]+"  time="+time[0]);
    }else if(f instanceof CIRC3){
      if(c1!=null)c1.sendReturn("");
      if(c2!=null)c2.sendReturn("");
      if(c4!=null)c4.sendReturn("");
      if(dec!=null)dec.sendReturn("");
      c3.sendReturn("difficulty="+difficulty[0]+"  valuation="+valuation[0]+"  time="+time[0]);
    }else if(f instanceof CIRC4){
      if(c1!=null)c1.sendReturn("");
      if(c2!=null)c3.sendReturn("");
      if(c3!=null)c4.sendReturn("");
      if(dec!=null)dec.sendReturn("");
      c4.sendReturn("difficulty="+difficulty[0]+"  valuation="+valuation[0]+"  time="+time[0]);
    }else if(f instanceof CircDec){
      if(c1!=null)c1.sendReturn("");
      if(c2!=null)c2.sendReturn("");
      if(c3!=null)c3.sendReturn("");
      if(c4!=null)c4.sendReturn("");
      dec.sendReturn("difficulty="+difficulty[0]+"  valuation="+valuation[0]+"  time="+time[0]);
    }else if(f instanceof CRCGUI){
      crc.sendReturn("difficulty="+difficulty[1]+"  valuation="+valuation[1]+"  time="+time[1]);
    }else if(f instanceof RSPC){
      rspc.sendReturn("difficulty="+difficulty[2]+"  valuation="+valuation[2]+"  time="+time[2]);
	}
  }

  public void setNew(){
    //this method resets all values of the applet
    c1=null;
    c2=null;
    c3=null;
    c4=null;
    dec=null;
    crc=null;
    rspc=null;
    difficulty=new int[3];
    valuation=new int[3];
    time=new String[3];
    z_diff=new int[3];
    state_zaehler=0;
  }

  public void close(String akt){
    //this method close the applet
    invisible(getObject(akt));
    if(gf!=null)
    	invisible(gf);
    if(p!=null)
    	invisible(p);
    if(u!=null)
    	invisible(u);
    t=null;
    cd=null;
    cdrom=null;
    form=null;
    c1=null;
    c2=null;
    c3=null;
    c4=null;
    dec=null;
    crc=null;
    rspc=null;
    u=null;
    gf=null;
    p=null;
    ocmf=null;
    applet.stop();
  }
}
