import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.border.*;
import javax.swing.*;
import javax.swing.BorderFactory;

public class CIRC4 extends JFrame {
	private Status state;
    private final String akt="CIRC4";
    private int myDifficulty;

    private JLabel qparitxt;// question;
    private JLabel qpari, leer1, leer2, leer3;
    private JLabel l1, l2, l3, l4, l5, l6, l7, l8;// JLabel for the given words;
    private JLabel i1,i2,i3,i4,i5,i6;// JLabels for the Icons;
    private JTextField qp1, qp2, qp3, qp4, qp5, qp6;//to give a solution tip;
    private JLabel loes1, loes2, loes3, loes4, loes5, loes6, sendReturn;//JLabels loes show the real solution
    private JLabel l[]=new JLabel[8];
    private Border border1, border2;
    private JPanel p1,p1p1,leiste,p2,p1p2, p1p3,p1p4;
    private TitledBorder tb1, tb2, tb3;
    private JButton b1, b2, b3, b4, b5, neu, test, solu, send;
    private Qparicode qparitaet;
    private ImageIcon right,wrong;

    private String b []=new String[8];//saves the given words;
    private String d []=new String[6];//saves the solution words;
    private int z=0;//variable;

    private Qparicode pparitaet;

    private JMenuBar menuBar;
    private JMenu m1, m2, m3, m4, m5;
    private JMenuItem m11, m12, m21, m22, m31, m41, m51, m52;

          public CIRC4(Status st,Image r,Image w){
            super("P-Parity");

            state=st;
            myDifficulty=0;

            Container c= getContentPane();
            c.setLayout(new BorderLayout());

            setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

	menubar();

    p1=new JPanel();
    p1.setLayout(null);

     /*Creates the Exercise Box*/
    p1p1=new JPanel();
    p1p1.setBounds(5,5,480,260);
    p1p1.setLayout(null);
    border1=BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    tb1=new TitledBorder(border1,"Exercise");
    tb1.setTitleColor(Color.black);
    p1p1.setBorder(tb1);
    qparitxt=new JLabel("<html><p>Determine the Q-parity with the help of the generator polynom:</p> p(x)  =  x<SUP>6</SUP> + \u03B2<SUP>10</SUP>x<SUP>5</SUP> + \u03B2<SUP>14</SUP>x<SUP>4</SUP> + \u03B2<SUP>4</SUP>x<SUP>3</SUP> + \u03B2<SUP>6</SUP>x<SUP>2</SUP> + \u03B2<SUP>9</SUP>x + \u03B2<SUP>6</SUP>: </html>"); new JLabel("<html><p>Determine the P-parity with the help of the generator polynom:</p> p(x)=x^6 + \u03B2^10*x^5 + \u03B2^14*x^4 + \u03B2^4*x^3 + \u03B2^6*x^2 + \u03B2^9*x + \u03B2^6: </html>");
    qparitxt.setForeground(Color.black);
    qparitxt.setBounds(15,10,450,70);
    p1p1.add(qparitxt);
    p1.add(p1p1);

     /*take the words from the Qparicode;*/

    pparitaet= new Qparicode(myDifficulty);
    b=pparitaet.get_Werte();
    d=pparitaet.get_Solu_for_app();


    int x=80;
    for(int o=0;o<8;o++){
      l[o]=new JLabel();
      l[o].setText((o+1)+".     "+b[o]);//puts the informationwords in the JLabels;
      p1p1.add(l[o]);
      l[o].setBounds(120,x,100,20);
      x+=20;
    }


     /*Creates new words*/
    neu= new JButton("New");
    neu.setBounds(310,210,80,25);
    p1p1.add(neu);
    neu.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        p1p4.setVisible(false);
        pparitaet= new Qparicode(myDifficulty);
    b=pparitaet.get_Werte();
    d=pparitaet.get_Solu_for_app();

         loes1.setText("");
         loes2.setText("");
         loes3.setText("");
         loes4.setText("");
         loes5.setText("");
         loes6.setText("");

         qp1.setText("");
        qp2.setText("");
        qp3.setText("");
        qp4.setText("");
        qp5.setText("");
        qp6.setText("");

         i1.setVisible(false);
         i2.setVisible(false);
         i3.setVisible(false);
         i4.setVisible(false);
         i5.setVisible(false);
         i6.setVisible(false);

         test.setEnabled(true);
         for(int p=0;p<8;p++){
           l[p].setText((p+1)+".     "+b[p]);
         }
     }});

   /*Creates the Solution Box*/
    p1p2= new JPanel();
    p1p2.setBounds(5,265,480,260);
    p1p2.setLayout(null);
    border1= BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    tb1= new TitledBorder(border1,"Solution");
    tb1.setTitleColor(Color.black);
    p1p2.setBorder(tb1);
    p1.add(p1p2);
    c.add(p1,BorderLayout.CENTER);

    qp1= new JTextField(4);
    qp2= new JTextField(4);
    qp3= new JTextField(4);
    qp4= new JTextField(4);
    qp5= new JTextField(4);
    qp6= new JTextField(4);
    qpari = new JLabel("P-parity :  ");

    p1p2.add(qp1);
    p1p2.add(qp2);
    p1p2.add(qp3);
    p1p2.add(qp4);
    p1p2.add(qp5);
    p1p2.add(qp6);
    p1p2.add(qpari);

    p1p4=new JPanel();//JPanel, where the real solution words are put in;
    p1p4.setBorder(BorderFactory.createLoweredBevelBorder());
    p1p4.setBounds(335,23,90,178);
    p1p4.setLayout(null);
    p1p4.setVisible(false);
    p1p2.add(p1p4);


    qp1.setBounds(90,30,120,25);
    qp2.setBounds(90,58,120,25);
    qp3.setBounds(90,86,120,25);
    qp4.setBounds(90,114,120,25);
    qp5.setBounds(90,142,120,25);
    qp6.setBounds(90,170,120,25);
    qpari.setBounds(25,30,70,25);


    i1  = new JLabel();
    i1.setVisible(false);
    i2  = new JLabel();
    i2.setVisible(false);
    i3  = new JLabel();
    i3.setVisible(false);
    i4  = new JLabel();
    i4.setVisible(false);
    i5  = new JLabel();
    i5.setVisible(false);
    i6  = new JLabel();
    i6.setVisible(false);
    right=new ImageIcon(r);
    wrong=new ImageIcon(w);

    p1p2.add(i1);
    p1p2.add(i2);
    p1p2.add(i3);
    p1p2.add(i4);
    p1p2.add(i5);
    p1p2.add(i6);

    i1.setBounds(270, 30, 25, 25);
    i2.setBounds(270, 58, 25, 25);
    i3.setBounds(270, 86, 25, 25);
    i4.setBounds(270,114, 25, 25);
    i5.setBounds(270,142, 25, 25);
    i6.setBounds(270,170, 25, 25);

     loes1=new JLabel();
     loes2=new JLabel();
     loes3=new JLabel();
     loes4=new JLabel();
     loes5=new JLabel();
     loes6=new JLabel();

     loes1.setBounds(5, 5, 150, 25);
     loes2.setBounds(5, 33, 150, 25);
     loes3.setBounds(5, 61, 150, 25);
     loes4.setBounds(5, 89,150, 25);
     loes5.setBounds(5, 117,150, 25);
     loes6.setBounds(5, 145,150, 25);

     p1p4.add(loes1);
     p1p4.add(loes2);
     p1p4.add(loes3);
     p1p4.add(loes4);
     p1p4.add(loes5);
     p1p4.add(loes6);

       /*Shows the solution*/
     solu= new JButton("Solution");
     p1p2.add(solu);
     solu.setBounds(340, 215, 80, 25);

     solu.addActionListener(new ActionListener(){
     public void actionPerformed(ActionEvent e){
        p1p4.setVisible(true);
        loes1.setText("        "+d[0]);
        loes1.setForeground(Color.blue);
        loes2.setText("        "+d[1]);
        loes2.setForeground(Color.blue);
        loes3.setText("        "+d[2]);
        loes3.setForeground(Color.blue);
        loes4.setText("        "+d[3]);
        loes4.setForeground(Color.blue);
        loes5.setText("        "+d[4]);
        loes5.setForeground(Color.blue);
        loes6.setText("        "+d[5]);
        loes6.setForeground(Color.blue);
        test.setEnabled(false);

     }});


    /* test the real solution with the solution from the user;*/
     test= new JButton("Test");
        p1p2.add(test);
        test.setBounds(105, 215, 80, 25);

        test.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
           boolean isright=true;
           send.setEnabled(true);
            if(qp1.getText().equals(d[0])){
              i1.setIcon(right);
              i1.setVisible(true);
            }else{
            	isright=false;
              i1.setIcon(wrong);
              i1.setVisible(true);
            }
            if(qp2.getText().equals(d[1])){
              i2.setIcon(right);
              i2.setVisible(true);
            }else{
              isright=false;
              i2.setIcon(wrong);
              i2.setVisible(true);
            }
            if(qp3.getText().equals(d[2])){
              i3.setIcon(right);
              i3.setVisible(true);
            }else{
              isright=false;
              i3.setIcon(wrong);
              i3.setVisible(true);
            }
            if(qp4.getText().equals(d[3])){
              i4.setIcon(right);
              i4.setVisible(true);
            }else{
              isright=false;
              i4.setIcon(wrong);
              i4.setVisible(true);
            }
            if(qp5.getText().equals(d[4])){
              i5.setIcon(right);
              i5.setVisible(true);
            }else{
              isright=false;
              i5.setIcon(wrong);
              i5.setVisible(true);
            }
            if(qp6.getText().equals(d[5])){
              i6.setIcon(right);
              i6.setVisible(true);
            }else{
              isright=false;
              i6.setIcon(wrong);
              i6.setVisible(true);
            }

        if(isright){
       		state.setDifficulty(akt);
       		state.setValuation(akt,1);
       		if(myDifficulty<2)
       			myDifficulty++;
       	}else{
      		state.setValuation(akt,-1);
      	}
        state.setTime(akt,pparitaet.getTime());
      }
    });


    leiste=new JPanel();
    leiste.setBorder( BorderFactory.createRaisedBevelBorder() );
    JButton b4=new JButton("Back");
    leiste.add(b4);
    JButton b5=new JButton("Next");
    leiste.add(b5);
    b5.setEnabled(false);
    JButton b6=new JButton("Menu");
    leiste.add(b6);
    JButton b7=new JButton("CIRC-Overview");
    leiste.add(b7);

    c.add(leiste,BorderLayout.SOUTH);

    b4.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }});

    b6.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }});

    b7.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showRS(akt);
      }});

    setSize(500,740);
    setVisible(true);


    p1p3=new JPanel();
    p1p3.setBounds(5,525,480,80);//5,230,480,330
    p1p3.setLayout(null);
    tb3=new TitledBorder(border1,"Online");
    tb3.setTitleColor(Color.black);
    p1p3.setBorder(tb3);
    send=new JButton("Send");
    send.setBounds(50,30,80,25);
    send.setEnabled(false);
    send.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
     	sendReturn(state.send(akt));
      }
    });
    p1p3.add(send);
    sendReturn=new JLabel();
    sendReturn.setForeground(Color.blue);
    sendReturn.setBounds(160,30,280,30);
    p1p3.add(sendReturn);
    p1.add(p1p3);

  }

	public void sendReturn(String s){
		sendReturn.setText(s);
	}

	private void menubar(){
          //MenuBar
            menuBar=new JMenuBar();
            m1=new JMenu("File");
            m2=new JMenu("View");
            m3=new JMenu("Menu");
            m4=new JMenu("Circ-Overview");
            m5=new JMenu("?");

            m11=new JMenuItem("New");
            m11.addActionListener(new ActionListener(){
              public void actionPerformed(ActionEvent e){
				p1p4.setVisible(false);
                                pparitaet= new Qparicode(myDifficulty);
                                    b=pparitaet.get_Werte();
                                    d=pparitaet.get_Solu_for_app();


         loes1.setText("");
         loes2.setText("");
         loes3.setText("");
         loes4.setText("");
         loes5.setText("");
         loes6.setText("");

         qp1.setText("");
        qp2.setText("");
        qp3.setText("");
        qp4.setText("");
        qp5.setText("");
        qp6.setText("");

         i1.setVisible(false);
         i2.setVisible(false);
         i3.setVisible(false);
         i4.setVisible(false);
         i5.setVisible(false);
         i6.setVisible(false);

         test.setEnabled(true);
         for(int p=0;p<8;p++){
           l[p].setText((p+1)+".     "+b[p]);
         }
            }});
          m1.add(m11);
          m1.addSeparator();

          m12=new JMenuItem("Quit");
          m12.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
				state.close(akt);
          }});
          m1.add(m12);
          menuBar.add(m1);

          m21=new JMenuItem("Back");
          m21.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
              state.lastState(akt);
            }});
          m2.add(m21);
          m2.addSeparator();

          m22=new JMenuItem("Next");
          m22.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
              //state.nextState(akt,"CIRC3");
          }});
        m2.add(m22);

        menuBar.add(m2);

        m31=new JMenuItem("Menu");
        m31.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            state.showMenu(akt);
        }});
      m3.add(m31);

      menuBar.add(m3);

      m41=new JMenuItem("Circ-Overview");
      m41.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent e){
          state.showRS(akt);
      }});
    m4.add(m41);

    menuBar.add(m4);

    m51=new JMenuItem("Help");
    m51.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
		state.showHelp(akt);
    }});
    m5.add(m51);
    m5.addSeparator();

    m52=new JMenuItem("<html>GF(2<SUP>4</SUP>)</html>");
    m52.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showGF();
    }});
    m5.add(m52);
    menuBar.add(m5);
    setJMenuBar(menuBar);

  	}
 }
