import java.util.*;
import java.lang.*;

public class CIRC_Decoding{

  private Qparicode decode;
  private String d []=new String[6];//array for the parity words of the Qparicode;
  private String codeword []=new String[14];//sum of b and d;
  private int z=0,j=0,i=0;//variables
  private long time;

  private Random r= new Random();

  private int cw_err1[][]= new int[8][4];//information words in binary form;
  private int cw_err2[][]= new int[6][4];// parity words in binary form;
  int cw_err3[][]= new int[14][4];//sum;

  private boolean error; //does an error occurces

  	/*Computes the Codewords */
  	public String[] CodeWords(){

      /*Takes the information word and the parity words from the QParicode*/
      time = System.currentTimeMillis();
      decode= new Qparicode(0);
      int help_inf[][]=decode.get_Infowort_binaer();
      for(i=0;i<8;i++){
        for (j = 0; j < 4; j++) {
          cw_err1[i][j] = help_inf[i][j];
        }
      }

      if(r.nextInt(2)==0)
      	error=true;
      else error=false;

      if(error){
      	int error_count=r.nextInt(2)+1;
      	int errorPos=r.nextInt(4)+4;

      	while(error_count>0){
      		error_count--;

      		int y=r.nextInt(4);

      		if(cw_err1[errorPos][y]==0)
      		cw_err1[errorPos][y]=1;
      		else cw_err1[errorPos][y]=0;

      		do{
      			int z=r.nextInt(4)+4;
      		}while(z==errorPos);
      	}
      }

      d=decode.get_Solu_for_app();


      /*Builds the codeword.
        The first eight words are from the informationword and
        the other words are the parity words*/

      int i=0;
      for(i=0;i<14;i++){
        if(i<8){
        	codeword[i]="";
        	for(int j=0;j<4;j++){
        		codeword[i]+= cw_err1[i][j];
        	}
        }else codeword[i]=d[i-8];
      }



      return codeword;
    }

    //if an error occures, returns true, else false
    public boolean isError(){
    	return error;
    }

    public String getTime(){
    	return Long.toString((System.currentTimeMillis()-time)/1000);
	}
}

