import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;
import javax.swing.border.*;

public class Circ1 extends JFrame{

  private Status state;
  private final String akt="Circ1";

  private CircCode code;
  private String s[];

  private Container myFrame;
  private JPanel p1,p1p1,p1p2,p2,leiste,p1p2Panel;
  private JButton b1,b2,b3,lb1,lb2,lb3,lb4;
  private JComboBox combo[];
  private JLabel l[]=new JLabel[27];
  private Border border1;
  private TitledBorder tb1,tb2;
  private ImageIcon right,wrong;

  private JPanel p1p3;
  private JLabel sendReturn;
  private JButton send;
  private TitledBorder tb3;

  private JMenuBar menuBar;
  private JMenu m1, m2,m3,m4,m5;
  private JMenuItem m11,m12,m21,m22,m31,m41,m51,m52;

  public Circ1(Status st,Image r,Image w){
    super("Delay");

    state=st;

    myFrame=getContentPane();
    myFrame.setLayout(new BorderLayout());

    setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

    right=new ImageIcon(r);
    wrong=new ImageIcon(w);

    menubar();
    //Creates the exercise box
    p1=new JPanel();
    p1.setLayout(null);

    p1p1=new JPanel();
    p1p1.setBounds(5,5,480,200);
    p1p1.setLayout(null);
    border1=BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    tb1=new TitledBorder(border1,"Exercise");
    tb1.setTitleColor(Color.black);
    p1p1.setBorder(tb1);

    //Labels for the information words and the question
    for(int i=0;i<17;i++){
      l[i]=new JLabel();
      l[i].setForeground(Color.black);
    }

    l[0].setBounds(30,10,450,70);
    l[0].setText("<html>Arrange the four information signals so that the CIRC-Encoder<p> can process them!</p> </html>");
    p1p1.add(l[0]);

    l[1].setBounds(30,90,150,20);
    l[1].setText("information signals =");
    p1p1.add(l[1]);

    code=new CircCode();
    s=code.newValues();
    //Puts the informationword elements, which was created in the CircCode, in the labels
    int y=90;
    for(int i=2;i<6;i++){
      l[i].setBounds(170,y,20,20);
      l[i].setText(""+(i-1)+".");
      p1p1.add(l[i]);

      l[i+4].setBounds(200,y,150,20);
      l[i+4].setText(s[i-2]);
      p1p1.add(l[i+4]);
      y+=20;
    }

    //Creates new elements of the informationword, like above
    b1=new JButton("New");
    b1.setBounds(320,125,80,25);
    b1.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        p1p2Panel.setVisible(false);
        getValues();
      }
    });
    b1.setVisible(true);
    p1p1.add(b1);
    p1.add(p1p1);

   //Creates the solution box
    p1p2=new JPanel();
    p1p2.setBounds(5,210,480,315);
    p1p2.setLayout(null);
    tb2=new TitledBorder(border1,"Solution");
    tb2.setTitleColor(Color.black);
    p1p2.setBorder(tb2);

    combo=new JComboBox[8];
    int z=40;
    s=code.getWords();
    p1p2Panel=new JPanel();
    p1p2Panel.setBorder(BorderFactory.createLoweredBevelBorder());
    p1p2Panel.setBounds(320,30,90,230);//290,30,90,230);
    p1p2Panel.setLayout(null);
    p1p2Panel.setVisible(false);
    for(int i=0;i<8;i++){
      if(i==4)z+=10;
      //creates the comboboxes
      combo[i] = new JComboBox(s);
      combo[i].setEditable( true );
      combo[i].setSelectedIndex(0);
      combo[i].setBounds(30,z,150,20);
      p1p2.add(combo[i]);

      //creates the labels for the information word
      l[i+10]=new JLabel();
      l[i+10].setBounds(215,z,25,20);
      l[i+10].setVisible(false);
      p1p2.add(l[i+10]);

      l[i+18]=new JLabel();
      l[i+18].setForeground(Color.blue);
      l[i+18].setBounds(30,z-30,60,20);
      p1p2Panel.add(l[i+18]);

      z+=25;
    };
    p1p2.add(p1p2Panel);
    //Test if the order is right
    b2=new JButton("Test");
    b2.setBounds(50,270,80,25);
    b2.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        send.setEnabled(true);
        String hilf[]=new String[8];
        for(int i=0;i<8;i++){
          hilf[i]=(String)combo[i].getSelectedItem();
        }
        boolean b[]=code.test(hilf);
        boolean visible =true;
        for(int i=0;i<8;i++){
          if(b[i])l[10+i].setIcon(right);   //right order
          else{
            l[10+i].setIcon(wrong);         //wrong order
            visible=false;
          }
          l[10+i].setVisible(true);
        }
        if(visible){
          b3.setEnabled(false);
          b2.setEnabled(false);
          state.setValuation(akt,1);       //for the send Option
          state.setDifficulty(akt);
        }else{
          state.setValuation(akt,-1);
        }
        state.setTime(akt,code.getTime());
      }
    });
    p1p2.add(b2);

    //Shows the right order of the words
    b3=new JButton("Solution");
    b3.setBounds(320,270,80,25);//290,270,90,25);
    b3.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        b2.setEnabled(false);
        p1p2Panel.setVisible(true);
        for(int i=0;i<8;i++){
          String hilf[]=code.getWords();
          l[i+18].setText(hilf[i]);
          l[i+18].setVisible(true);
        }
      }
    });

    p1p2.add(b3);

    p1.add(p1p2);

    myFrame.add(p1,BorderLayout.CENTER);

    //Creates the Online box
    p1p3=new JPanel();
    p1p3.setBounds(5,530,480,80);
    p1p3.setLayout(null);
    tb3=new TitledBorder(border1,"Online");
    tb3.setTitleColor(Color.black);
    p1p3.setBorder(tb3);

    send=new JButton("Send");
    send.setBounds(50,30,80,25);
    send.setEnabled(false);
    send.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        sendReturn(state.send(akt));
      }
    });
    p1p3.add(send);
    sendReturn=new JLabel();
    sendReturn.setForeground(Color.blue);
    sendReturn.setBounds(160,30,280,25);
    p1p3.add(sendReturn);
    p1.add(p1p3);

    //Buttonledge
    leiste=new JPanel();
    leiste.setBorder( BorderFactory.createRaisedBevelBorder() );
    JButton b4=new JButton("Back");
    leiste.add(b4);
    JButton b5=new JButton("Next");
    leiste.add(b5);
    JButton b6=new JButton("Menu");
    leiste.add(b6);
    JButton b7=new JButton("CIRC-Overview");
    leiste.add(b7);

    myFrame.add(leiste,BorderLayout.SOUTH);

    b4.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }
    });

    b5.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.nextState(akt,"CIRC2");
      }
    });

    b6.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }
    });

    b7.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showRS(akt);
      }
    });
  }
  //Puts the words in the combobox ,the old words out
  private void getValues(){
    b2.setEnabled(true);
    b3.setEnabled(true);
    for(int i=0;i<8;i++){//set the Icons unvisible
      l[i+10].setVisible(false);
      l[i+18].setVisible(false);
    }

    //take the new words and put them in the lables
    s=code.newValues();
    for(int i=6;i<10;i++){
      l[i].setText(s[i-6]);
    }
    String hilf[]=code.getWords();
    for(int i=0;i<8;i++){
      combo[i].removeAllItems();
      for(int j=0;j<8;j++){
        combo[i].addItem(hilf[j]);
      }
      combo[i].setVisible(true);
    }
  }

  private void menubar(){
    //Creates the MenuBar
    menuBar=new JMenuBar();
    m1=new JMenu("File");
    m2=new JMenu("View");
    m3=new JMenu("Menu");
    m4=new JMenu("Circ-Overview");
    m5=new JMenu("?");

    m11=new JMenuItem("New");
    m11.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        p1p2Panel.setVisible(false);
        getValues();
      }
    });
    m1.add(m11);
    m1.addSeparator();

    m12=new JMenuItem("Quit");
    m12.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.close(akt);
      }
    });
    m1.add(m12);

    menuBar.add(m1);

    m21=new JMenuItem("Back");
    m21.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }
    });
    m2.add(m21);
    m2.addSeparator();

    m22=new JMenuItem("Next");
    m22.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.nextState(akt,"CIRC2");
      }
    });
    m2.add(m22);

    menuBar.add(m2);

    m31=new JMenuItem("Menu");
    m31.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }
    });
    m3.add(m31);

    menuBar.add(m3);

    m41=new JMenuItem("Circ-Overview");
    m41.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showRS(akt);
      }
    });
    m4.add(m41);

    menuBar.add(m4);

    m51=new JMenuItem("Help");
    m51.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showHelp(akt);
      }
    });
    m5.add(m51);
    m5.addSeparator();

    m52=new JMenuItem("<html>GF(2<SUP>4</SUP>)</html>");
    m52.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showGF();
      }
    });
    m5.add(m52);

    menuBar.add(m5);

    setJMenuBar(menuBar);
  }

  public void sendReturn(String s){
    sendReturn.setText(s);
  }

}