import java.lang.*;
import java.util.*;

public class CircCode{

  private String s[];//Solution
  private String t[];
  private Random r;
  private long time;

  public CircCode(){
    s=new String[8];
    r=new Random();
  }

  public String[] getWords(){
    //Words to fill the comboboxes
    return t;
  }

  public boolean[] test(String[] words){
    //proof the solution which was created in the GUI CIRC1
    boolean[] test=new boolean[8];
    for(int i=0;i<8;i++){
      test[i]=true;
      if(!words[i].equals(s[i])){
        test[i]=false;
      }
    }
    return test;
  }


  public String[] newValues(){
    //generated new words
    time = System.currentTimeMillis();
    StringBuffer sB=new StringBuffer(8);
    String hilf[]=new String[4];
    String h;
    t=new String[8];

    //Generates 8x8 words; this is also the solution
    for(int i=0;i<8;i++){
      for(int j=0;j<4;j++){
        sB=sB.append(r.nextInt(2));
      }
      s[i]=sB.substring(0);
      for(int j=0;j<i;j++){
      	if(s[i].equals(s[j]))
      		i--;
      }
      sB=new StringBuffer(8);
    }

    int k=0;
    //8x8 bit words are build to 4x16 bit words
    for(int i=0;i<7;i+=2){
      hilf[k]=s[i]+s[i+1];
      t[i]=s[i];
      t[i+1]=s[i+1];
      k++;
    }


    return hilf;
  }

  public String getTime(){
    return Long.toString((System.currentTimeMillis()-time)/1000);
  }
}