import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;

import java.awt.event.*;
import javax.swing.*;
import java.applet.*;
import java.awt.*;
import java.lang.*;


public class CircDec extends JFrame{

        private Status state;
        private final String akt="CircDec";
        private int myDifficulty;


        private Container c;
        private JPanel leiste,pane,pradio,pcheck,p1p3;
        private JButton b4,b5,b6,b7,send;
        private JLabel l1,sendReturn;

        private ImageIcon right;
        private ImageIcon wrong;
        private GridLayout g1,g2;
        private JPanel pcheck1,p1,p2,panel;
        private Border border1,border2;
        private JLabel l[],quest,word,sol;
        private JButton b1,b2,b3;
        private JTextArea t;
        private String cw[]= new String[14];//String array for the codewords;
        private String cd; //String for the information word;
        private int i,j;//variables
        private int[] expo= new int[3];//saves the exponents of the error positions;
        private int err;//how many errors are in the Codeword;
        private CIRC_Decoding c_dec;
        private JRadioButton r1,r2;
		private ButtonGroup group;
   		private JLabel l11,l12;

        private JMenuBar menuBar;
        private JMenu m1, m2,m3,m4,m5;
        private JMenuItem m11,m12,m21,m22,m31,m41,m51,m52,m53;

        public CircDec(Status st,Image r,Image w){
          super("Circ-Decoding");

          state=st;
          right=new ImageIcon(r);
          wrong=new ImageIcon(w);

    	  setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
          myDifficulty=0;

          c=getContentPane();

          menubar();

          panel=new JPanel();
          panel.setLayout(null);

          /*Panel for the Exercise-Box */

          p1=new JPanel();
          p1.setLayout(null);
          p1.setBounds(3,0,485,220);
          border1=BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
          TitledBorder tb1=new TitledBorder(border1,"Exercise");
          tb1.setTitleColor(Color.black);
          p1.setBorder(tb1);

          quest=new JLabel();
          quest.setBounds(35,30,450,40);
          quest.setForeground(Color.black);
          quest.setText("<html><p>Is the codeword transmitted correctly?</p> p(x)  =  x<SUP>6</SUP> + \u03B2<SUP>10</SUP>x<SUP>5</SUP> + \u03B2<SUP>14</SUP>x<SUP>4</SUP> + \u03B2<SUP>4</SUP>x<SUP>3</SUP> + \u03B2<SUP>6</SUP>x<SUP>2</SUP> + \u03B2<SUP>9</SUP>x + \u03B2<SUP>6</SUP>: </html> ");
          p1.add(quest);

          word=new JLabel();
          word.setForeground(Color.black);
          word.setText("Codeword =");
          word.setBounds(35,110,80,20);
          p1.add(word);

          /* Takes the codeword from the CIRC_Decoding Code and put it in a string.
             This String is need to put the codeword in the TextArea*/

          c_dec = new CIRC_Decoding();
          cw=c_dec.CodeWords();

          t=new JTextArea("",350 ,38 );
          t.setLineWrap(true);
          t.setWrapStyleWord(true);

          cd="";

          for(int j=0;j<14;j++){
            cd = cd + cw[j] + " ";
          }

          t.setText(cd);
          t.setBounds(110,110,350,38);
          t.setBorder(BorderFactory.createEtchedBorder());
          p1.add(t);

          //Creates new Codewords like above.
          b1=new JButton("New");
          b1.setBounds(190,165,80,25);
          p1.add(b1);

          b1.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
              b2.setEnabled(true);
              b3.setEnabled(true);
              r1.setEnabled(true);
              r2.setEnabled(true);
              sol.setVisible(false);
              l11.setVisible(false);
              c_dec=new CIRC_Decoding();
              cw = c_dec.CodeWords();

              cd="";
              for(int w=0;w<14;w++){
                cd=cd+cw[w]+" ";
              }
              t.setText(cd);
          	}
          });

          panel.add(p1);

        /*Panel for the Solution-Box*/
        p2=new JPanel();
        p2.setLayout(null);
        p2.setBounds(3,220,485,220);
        TitledBorder tb2=new TitledBorder(border1,"Solution");
        tb2.setTitleColor(Color.black);
        p2.setBorder(tb2);

	//does an error occor
    r1=new JRadioButton(" YES ");
    r1.setSelected(true);
    r2=new JRadioButton(" NO ");
    group = new ButtonGroup();
    group.add(r1);
    group.add(r2);
    JPanel radioPanel = new JPanel();
    radioPanel.setBounds(40,40,100,80);
    radioPanel.setLayout(new GridLayout(0, 1));
    radioPanel.add(r1);
    radioPanel.add(r2);
    p2.add(radioPanel);

    l11=new JLabel();
    l11.setBounds(180,60,40,40);
    l11.setVisible(false);
    p2.add(l11);

    b2=new JButton("Test");		//test-button
    b2.setBounds(280,70,80,25);
    b2.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        send.setEnabled(true);
    	b3.setEnabled(false);
        if((!c_dec.isError()&&r1.isSelected())||
           (c_dec.isError()&&r2.isSelected())){
          l11.setIcon(right);
          l11.setVisible(true);
          b2.setEnabled(false);
          b3.setEnabled(false);
          r1.setEnabled(false);
          r2.setEnabled(false);
          state.setValuation(akt,1);
          state.setDifficulty(akt,1);
          if(myDifficulty<1)
            myDifficulty++;
        }else{
          l11.setIcon(wrong);
          l11.setVisible(true);
          state.setValuation(akt,-1);
        }
        b2.setEnabled(false);
        state.setTime(akt,c_dec.getTime());	//calculate the time, that user have needed to calculate solution
      }
    });
    p2.add(b2);

    b3=new JButton("Solution");		//solution-button
    b3.setBounds(40,150,80,25);
    b3.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        if(c_dec.isError())
          sol.setText("Yes, the received codeword is correct!");
        else sol.setText("No, the received codeword is incorrect!");
        sol.setVisible(true);
        b2.setEnabled(false);
        r1.setEnabled(false);
        r2.setEnabled(false);
      }
    });
    p2.add(b3);

    sol=new JLabel();
    sol.setBounds(160,150,300,20);
    sol.setForeground( Color.blue );
   	p2.add(sol);

   	panel.add(p2);

    /*Creates the panel for the Online-Box*/

    p1p3=new JPanel();
    p1p3.setBounds(3,440,485,80);
    p1p3.setLayout(null);
    TitledBorder tb3=new TitledBorder(border1,"Online");
    tb3.setTitleColor(Color.black);
    p1p3.setBorder(tb3);
    send=new JButton("Send");
    send.setBounds(50,30,80,25);
    send.setEnabled(false);
    send.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
     	sendReturn(state.send(akt));
             sendReturn.setVisible(true);
      }
    });
    p1p3.add(send);
    sendReturn=new JLabel();
    sendReturn.setForeground(Color.blue);
    sendReturn.setBounds(160,30,280,25);
    p1p3.add(sendReturn);
    panel.add(p1p3);


    c.add(panel,BorderLayout.CENTER);

    leiste=new JPanel();
    leiste.setBorder( BorderFactory.createRaisedBevelBorder() );
    JButton b4=new JButton("Back");
    b4.setToolTipText("CIRC");
    leiste.add(b4);
    JButton b5=new JButton("Next");
    b5.setEnabled(false);
    leiste.add(b5);
    JButton b6=new JButton("Menu");
    leiste.add(b6);
    JButton b7=new JButton("CIRC-Overview");
    leiste.add(b7);

    c.add(leiste,BorderLayout.SOUTH);

    b4.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }
    });

    b6.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }
    });

    b7.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showRS(akt);
      }
    });
  }


  public void sendReturn(String s){
    sendReturn.setText(s);
  }

  //Menu-Bar
  private void menubar(){

    menuBar=new JMenuBar();
    m1=new JMenu("File");
    m2=new JMenu("View");
    m3=new JMenu("Menu");
    m4=new JMenu("Circ-Overview");
    m5=new JMenu("?");

    //Creates new Codewords with the help of CIRC-Decoding;
    m11=new JMenuItem("New");
    m11.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
                      b2.setEnabled(true);
              b3.setEnabled(true);
              r1.setEnabled(true);
              r2.setEnabled(true);
              sol.setVisible(false);
              l11.setVisible(false);
              c_dec=new CIRC_Decoding();
              cw = c_dec.CodeWords();

              cd="";
              for(int w=0;w<14;w++){
                cd=cd+cw[w]+" ";
              }
              t.setText(cd);
      }
    });
    m1.add(m11);
    m1.addSeparator();

    m12=new JMenuItem("Quit");
    m12.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
				state.close(akt);
      }
    });
    m1.add(m12);

    menuBar.add(m1);

    m21=new JMenuItem("Back");
    m21.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }
    });
    m2.add(m21);
    m2.addSeparator();

    m22=new JMenuItem("Next");
    m22.setEnabled(false);
    m2.add(m22);

    menuBar.add(m2);

    m31=new JMenuItem("Menu");
    m31.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }
    });
    m3.add(m31);

    menuBar.add(m3);

    m41=new JMenuItem("Circ-Overview");
    m41.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showRS(akt);
      }
    });
    m4.add(m41);

    menuBar.add(m4);

    m51=new JMenuItem("Help");
    m51.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showHelp(akt);
      }
    });
    m5.add(m51);
    m5.addSeparator();

    m52=new JMenuItem("<html>GF( 2<SUP>4</SUP> )</html>");
    m52.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showGF();
      }
    });
    m5.add(m52);

    menuBar.add(m5);

    setJMenuBar(menuBar);
  }
}
