import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import javax.swing.border.*;
import java.lang.*;
import java.util.*;

public class RSPC extends JFrame{

  private Status state;
  private final String akt = "RSPC";
  private ProductCode pdc,pdcDec;
  private int myDifficultyDec;

  private Container c;
  private JButton b4, b5, b6,send,senddec,ne, test, solu,nedec,testdec,soludec;
  private JMenuBar menuBar;
  private JMenu m1, m2, m3, m4, m5;
  private JMenuItem m11, m12, m21, m22, m31, m41, m51, m52;
  private JPanel pap1, pap2, pa, p1p1, p12,leiste,pap3,pb,pbp1,pbp1p1,pbp2,pbp2p,pbp3;
  private TitledBorder tb1, tb2,tb3;
  private Border border1, border2;
  private JLabel exercise,sendReturn,exercisedec,sendReturndec,ls[][],lsdec[][];
  private JLabel l[] = new JLabel[16];
  private JComboBox cbp[][],cbq[][];
  private String s[] = {" ","0", "1"};//content of comboboxes
  private boolean draw1,draw2,enc;
  private ActionListener NEW,NEWdec;
  private JToggleButton[][] toggle;
  private JTabbedPane jTabbedPaneEncDec;

  public RSPC(Status st,Image r,Image w){
    super("RSPC");

    state=st;
    enc=true;
    myDifficultyDec=0;
    c = getContentPane();
    c.setLayout(new BorderLayout());

    setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

    setMenuBar();

//ENCODING
    pa = new JPanel();
    pa.setLayout(null);

    //Exercise-part
    pap1 = new JPanel();
    pap1.setBounds(5, 5, 480, 295);
    pap1.setLayout(null);
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    tb1 = new TitledBorder(border1, "Exercise");
    tb1.setTitleColor(Color.black);
    pap1.setBorder(tb1);

    exercise = new JLabel("Calculate the Parity Bits with the Hamming code!");
    exercise.setBounds(20, 10, 400, 40);
    pap1.add(exercise);

    p1p1 = new JPanel();
    p1p1.setBounds(30, 60, 310, 220);
    p1p1.setLayout(new GridLayout(7, 7));
    ((GridLayout)p1p1.getLayout()).setHgap(3);
    ((GridLayout)p1p1.getLayout()).setVgap(3);
    cbp=new JComboBox[4][3];
    cbq=new JComboBox[3][7];

    int lz=0;

    for (int i = 0; i < 7; i++) {
      for (int j = 0; j < 7; j++) {
        if(i < 4 && j < 4) {
          l[lz] = new JLabel();
          p1p1.add(l[lz]);
          lz++;
        }
        if(i<4&&j>=4){
          cbp[i][j-4] = new JComboBox(s);
          p1p1.add(cbp[i][j-4]);
        }
        if(i>=4){
          cbq[i-4][j]=new JComboBox(s);
          p1p1.add(cbq[i-4][j]);
        }
      }
    }

    ne = new JButton("New");
    ne.setBounds(360, 120, 80, 25);
    pap1.add(ne);

    pdc=new ProductCode();

    test = new JButton("Test");
    test.setBounds(360, 160, 80, 25);
    pap1.add(test);

    pap1.add(p1p1);

    pa.add(pap1);

    //Solution-part
    pap2 = new JPanel();
    pap2.setBounds(5, 300, 480, 225);
    pap2.setLayout(null);
    tb2 = new TitledBorder(border1, "Solution");
    tb2.setTitleColor(Color.black);
    pap2.setBorder(tb2);

    solu= new JButton("Solution");
    solu.setBounds(180,90,100,50);
    pap2.add(solu);

    p12 = new JPanel();
    p12.setVisible(false);
    p12.setBounds(30, 20, 310, 195);

    ls=new JLabel[7][7];
    p12.setLayout(new GridLayout(7, 7));
    for (int i = 0; i < 7; i++) {
      for (int j = 0; j < 7; j++) {
        ls[i][j] = new JLabel();
        p12.add(ls[i][j]);
        if(j>3||i>3)ls[i][j].setForeground(Color.blue);
      }
    }

    pap2.add(p12);

    pa.add(pap2);

    //Online
    pap3=new JPanel();
    pap3.setBounds(5,528,480,80);
    pap3.setLayout(null);
    tb3=new TitledBorder(border1,"Online");
    tb3.setTitleColor(Color.black);
    pap3.setBorder(tb3);

    send=new JButton("Send");
    send.setBounds(50,30,80,25);
    send.setEnabled(false);
    pap3.add(send);

    sendReturn=new JLabel();
    sendReturn.setForeground(Color.blue);
    sendReturn.setBounds(160,30,280,25);
    pap3.add(sendReturn);

    pa.add(pap3);

    ne.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        test.setEnabled(true);
        draw1= false;
        solu.setVisible(true);
        p12.setVisible(false);

        for(int i=0;i<4;i++){
          for(int j=0;j<3;j++){
            cbp[i][j].setBackground(Color.lightGray);
            cbp[i][j].setSelectedItem(" ");
          }
        }
        for(int i=0;i<3;i++){
          for(int j=0;j<7;j++){
            cbq[i][j].setBackground(Color.lightGray);
            cbq[i][j].setSelectedItem(" ");
          }
        }
        newEnc();
        repaint();
      }
    });

    newEnc();

    test.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        send.setEnabled(true);
        int[][] hilf1=new int[4][3];
        int[][] hilf2=new int[3][7];
        boolean[][] bp;
        boolean[][] bq;
        for (int i = 0; i < 4; i++) {
          for (int j = 0; j < 3; j++) {
            String h=(String)cbp[i][j].getSelectedItem();
            if(!(h.equals("1")||h.equals("0")))hilf1[i][j]=-1;
            else hilf1[i][j]=Integer.parseInt(h);
          }
        }
        bp=pdc.getPParity(hilf1);

        for (int i = 0; i < 3; i++) {
          for (int j = 0; j < 7; j++) {
            String h=(String)cbq[i][j].getSelectedItem();
            if(!(h.equals("1")||h.equals("0")))hilf2[i][j]=-1;
            else hilf2[i][j]=Integer.parseInt(h);
          }
        }
        bq=pdc.getQParity(hilf2);

        boolean isright=true;
        for (int i = 0; i < 4; i++) {
          for (int j = 0; j < 3; j++) {
            if(bp[i][j])
              cbp[i][j].setBackground(Color.green);
            else{
              cbp[i][j].setBackground(Color.red);
              isright=false;
            }
          }
        }

        for (int i = 0; i < 3; i++) {
          for (int j = 0; j < 7; j++) {
            if(bq[i][j])
              cbq[i][j].setBackground(Color.green);
            else{
              cbq[i][j].setBackground(Color.red);
              isright=false;
            }
          }
        }
        repaint();
        if(isright){
          state.setDifficulty(akt,0);
          state.setValuation(akt,1);
        }else{
          state.setValuation(akt,-1);
        }
        state.setTime(akt,pdc.getTime());
      }
    });

    solu.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        test.setEnabled(false);
        draw1= true;
        solu.setVisible(false);
        p12.setVisible(true);
        int[][] sol=pdc.getSolution();
        for (int i=0; i < 7; i++) {
          for (int j = 0; j < 7; j++) {
            ls[i][j].setText(""+sol[i][j]);
          }
        }
        repaint();
      }
    });

    send.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        sendReturn.setText(state.send(akt));
      }
    });

//DECODING
    pb=new JPanel();
    pb.setLayout(null);

    //exercise
    pbp1=new JPanel();
    pbp1.setBounds(5, 5, 480, 295);
    pbp1.setLayout(null);
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    pbp1.setBorder(tb1);
    pb.add(pbp1);

    exercisedec = new JLabel("Please select the bits, which are incorrect!");
    exercisedec.setBounds(30, 15, 400, 40);
    pbp1.add(exercisedec);

    pbp1p1=new JPanel();
    pbp1p1.setLayout(new GridLayout(7,7));
    ((GridLayout)pbp1p1.getLayout()).setHgap(3);
    ((GridLayout)pbp1p1.getLayout()).setVgap(3);
    pbp1p1.setBounds(30,60,310,220);

    toggle=new JToggleButton[7][7];
    for(int i=0;i<7;i++){
      for(int j=0;j<7;j++){
        toggle[i][j]=new JToggleButton("",true);
        toggle[i][j].setBackground(Color.yellow);
        pbp1p1.add(toggle[i][j]);
        repaint();
      }

    }

    pbp1.add(pbp1p1);

    nedec = new JButton("New");
    nedec.setBounds(360, 160, 80, 25);
    pbp1.add(nedec);

    pdcDec=new ProductCode();

    testdec = new JButton("Test");
    testdec.setBounds(360, 200, 80, 25);
    pbp1.add(testdec);


    //solution
    pbp2 = new JPanel();
    pbp2.setBounds(5, 300, 480, 225);
    pbp2.setLayout(null);
    pbp2.setBorder(tb2);

    soludec= new JButton("Solution");
    soludec.setBounds(180,90,100,50);
    pbp2.add(soludec);

    pbp2p = new JPanel();
    pbp2p.setVisible(false);
    pbp2p.setBounds(30, 20, 310, 195);
    pbp2p.setLayout(new GridLayout(7, 7));

    lsdec=new JLabel[7][7];
    for (int i = 0; i < 7; i++) {
      for (int j = 0; j < 7; j++) {
        lsdec[i][j] = new JLabel();
        pbp2p.add(lsdec[i][j]);
      }
    }

    pbp2.add(pbp2p);

    pb.add(pbp2);

    //online
    pbp3=new JPanel();
    pbp3.setBounds(5,528,480,80);
    pbp3.setLayout(null);
    pbp3.setBorder(tb3);
    senddec=new JButton("Send");
    senddec.setBounds(50,30,80,25);
    senddec.setEnabled(false);
    senddec.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        sendReturndec.setText(state.send(akt));
      }
    });
    pbp3.add(senddec);

    sendReturndec=new JLabel();
    sendReturndec.setForeground(Color.blue);
    sendReturndec.setBounds(160,30,280,25);
    pbp3.add(sendReturndec);

    pb.add(pbp3);

    jTabbedPaneEncDec=new JTabbedPane ();
    jTabbedPaneEncDec.addChangeListener(new ChangeListener(){
      public void stateChanged(ChangeEvent e){
        if(jTabbedPaneEncDec.getSelectedIndex()==0){
          enc=true;
          repaint();
        }else{
          enc=false;
          repaint();
        }
      }
    });

    c.add(jTabbedPaneEncDec,BorderLayout.CENTER);

    jTabbedPaneEncDec.add(pa,"Encoding");
    jTabbedPaneEncDec.add(pb,"Decoding");

    //Buttonledge
    leiste = new JPanel();
    leiste.setBorder(BorderFactory.createRaisedBevelBorder());

    JButton b4 = new JButton("Back");
    b4.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        state.lastState(akt);
      }
    });
    leiste.add(b4);

    JButton b5 = new JButton("Next");
    b5.setEnabled(false);
    leiste.add(b5);

    JButton b6 = new JButton("Menu");
    b6.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        state.showMenu(akt);
      }
    });

    leiste.add(b6);
    c.add(leiste, BorderLayout.SOUTH);

    nedec.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        for(int i=0;i<7;i++){
          for(int j=0;j<7;j++){
            toggle[i][j].setEnabled(true);
            toggle[i][j].setSelected(true);
            toggle[i][j].setBackground(Color.yellow);
            repaint();
          }
        }
        testdec.setEnabled(true);
        draw2= false;
        repaint();
        soludec.setVisible(true);
        pbp2p.setVisible(false);
        newDec();
      }
    });

    newDec();

    testdec.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        senddec.setEnabled(true);
        boolean[][] hilf=new boolean[7][7];
        for(int i=0;i<7;i++){
          for(int j=0;j<7;j++){
            if(!toggle[i][j].isSelected())
              hilf[i][j]=false;
            else
              hilf[i][j]=true;
          }
        }
        boolean isright=true;
        int[][] h=pdcDec.testDec(hilf);
        for(int i=0;i<7;i++){
          for(int j=0;j<7;j++){
            if(h[i][j]==-1){
              isright=false;
              toggle[i][j].setBackground(Color.red);
            }else if(h[i][j]==0){
              toggle[i][j].setBackground(Color.green);
              toggle[i][j].setEnabled(false);
            }
          }
        }
        repaint();
        if(isright){
          state.setDifficulty(akt,1);
          state.setValuation(akt,1);
          if(myDifficultyDec<1)
            myDifficultyDec++;
        }else
          state.setValuation(akt,-1);
        state.setTime(akt,pdcDec.getTime());
      }
    });

    soludec.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        testdec.setEnabled(false);
        draw2= true;
        repaint();
        soludec.setVisible(false);
        pbp2p.setVisible(true);
        int[][] sol=pdcDec.getSolution();
        boolean[][] errorPos=pdcDec.getErrorPos();
        for (int i=0; i < 7; i++) {
          for (int j = 0; j < 7; j++) {
            if(!errorPos[i][j])
              lsdec[i][j].setForeground(Color.blue);
            lsdec[i][j].setText(""+sol[i][j]);
          }
        }
      }
    });
  }

  public void sendReturn(String s){
    if(jTabbedPaneEncDec.getSelectedIndex()==0){
		sendReturn.setText(s);
    }else{
		sendReturndec.setText(s);
	}
  }


  private void setMenuBar(){
    //Menuleiste
    menuBar = new JMenuBar();
    m1 = new JMenu("File");
    m2 = new JMenu("View");
    m3 = new JMenu("Menu");
    m4 = new JMenu("Circ-Overview");
    m5 = new JMenu("?");

    m11 = new JMenuItem("New");
    m11.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        if(jTabbedPaneEncDec.getSelectedIndex()==0){
          test.setEnabled(true);
          draw1= false;
          solu.setVisible(true);
          p12.setVisible(false);

          for(int i=0;i<4;i++){
            for(int j=0;j<3;j++){
              cbp[i][j].setBackground(Color.lightGray);
              cbp[i][j].setSelectedItem(" ");
            }
          }
          for(int i=0;i<3;i++){
            for(int j=0;j<7;j++){
              cbq[i][j].setBackground(Color.lightGray);
              cbq[i][j].setSelectedItem(" ");
            }
          }
          newEnc();
          repaint();
        }else{
          for(int i=0;i<7;i++){
            for(int j=0;j<7;j++){
              toggle[i][j].setEnabled(true);
              toggle[i][j].setSelected(true);
              toggle[i][j].setBackground(Color.yellow);
              repaint();
            }
          }
          testdec.setEnabled(true);
          draw2= false;
          repaint();
          soludec.setVisible(true);
          pbp2p.setVisible(false);
          newDec();
        }
      }
    });
    m1.add(m11);
    m1.addSeparator();

    m12 = new JMenuItem("Quit");
    m12.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
				state.close(akt);
      }
    });
    m1.add(m12);

    menuBar.add(m1);

    m21 = new JMenuItem("Back");
    m21.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        state.lastState(akt);
      }
    });
    m2.add(m21);
    m2.addSeparator();

    m22 = new JMenuItem("Next");
    m22.setEnabled(false);
    m2.add(m22);

    menuBar.add(m2);

    m31 = new JMenuItem("Menu");
    m31.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        state.showMenu(akt);
      }
    });
    m3.add(m31);

    menuBar.add(m3);

    m41 = new JMenuItem("Circ-Overview");
    m41.setEnabled(false);
    m4.add(m41);

    menuBar.add(m4);

    m51 = new JMenuItem("Help");
    m51.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        state.showHelp(akt,jTabbedPaneEncDec.getSelectedIndex());
      }
    });
    m5.add(m51);
    m5.addSeparator();
    m52 = new JMenuItem("Parity");
	m52.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
		state.showParity();
      }
    });
    m5.add(m52);
    menuBar.add(m5);
    setJMenuBar(menuBar);
  }

  public void paint(Graphics g){
    super.paint(g);
    g.setColor(Color.black);
    Graphics2D g2=(Graphics2D)g;
    Stroke stroke = new BasicStroke( 2 );
    g2.setStroke( stroke );
    //in Exercise-Matrix encoding
    g.drawLine(215, 145, 215, 355);
    g.drawLine(43, 266, 343, 266);

    if(enc){
      //in Solution- Matrix
      if(draw1){
        g2.drawLine(42, 506, 310, 506);
        g2.drawLine(200, 406, 200, 578);
      }
    }else{
      //in Solution- Matrix
      if(draw2){
        g2.drawLine(42, 506, 310, 506);
        g2.drawLine(200, 406, 200, 578);
      }
    }
  }

  private void newEnc(){
    int[][] info=pdc.getInfo();
    int lz=0;
    for (int i = 0; i < 4; i++) {
      for (int j = 0; j < 4; j++) {
        l[lz].setForeground(Color.black);
        l[lz].setText("      "+info[i][j]);
        lz++;
      }
    }
  }

  private void newDec(){
    testdec.setEnabled(true);
    int[][] hilf;
    hilf=pdcDec.getInfoDec(myDifficultyDec);
    for(int i=0;i<7;i++){
      for(int j=0;j<7;j++){
        toggle[i][j].setText(""+hilf[i][j]);
        lsdec[i][j].setForeground(Color.black);
      }
    }
  }
}




